#include <stdlib.h>
#include <time.h>
#include <stdio.h>
#include <gmp.h>


int main(int argc, char ** argv)
{
  int i, rang;
  long int x, n;
  mpz_t resultat, mpg_x;
  long int debut, apres_premier, apres_second;

  /*Initialisations*/
  if (argc!=3){
    fprintf(stderr,"Le programme prend obligatoirement deux arguments.\n");
    return(-1);
  }
  n = atol(argv[1]);
  x = atoi(argv[2]);
  mpz_init(resultat);
  mpz_init(mpg_x);
  mpz_set_ui(mpg_x, x);

  /* Premier algorithme */
  debut  = clock();
  mpz_set_ui(resultat, x);
  for(i=2; i<=n; i++) mpz_mul(resultat, mpg_x, resultat);
  fprintf(stderr,"resultat = ");
  mpz_out_str(stderr, 10, resultat);
  fprintf(stderr,"\n");
  apres_premier = clock();

  /* Deuxieme algorithme */
  mpz_set_ui(resultat, x);
  /*On determine d'abord le rang du bit de poids fort*/
  rang = sizeof(long int)*8-1; 
  while(((n >> rang)==0)&&(rang>0)) rang--;

  for(rang = rang-1; rang >=0; rang--){
    if ((n >> rang)&1){
      mpz_mul(resultat, resultat, resultat);
      mpz_mul(resultat, mpg_x, resultat);
    }
    else{
      mpz_mul(resultat, resultat, resultat);
    }
  }
  fprintf(stderr,"resultat = ");
  mpz_out_str(stderr, 10, resultat);
  fprintf(stderr,"\n");

  apres_second  = clock();
    
  /* Affichage des temps d'execution*/
  fprintf(stderr,"Premier  algorithme: %.3lf\nDeuxieme algorithme: %.3lf\n",
	  (1.0*(apres_premier-debut))/CLOCKS_PER_SEC, 
	  (1.0*(apres_second-apres_premier))/CLOCKS_PER_SEC);
  return 0;
}
