#include <stdlib.h>
#include <time.h>
#include <stdio.h>

int main(int argc, char ** argv)
{
  int i, rang;
  long int n, x, resultat;
  long int debut, apres_premier, apres_second;
  
  /* Initialisations*/
  if (argc!=3){
    fprintf(stderr,"Le programme prend obligatoirement deux arguments.\n");
    return(-1);
  }
  n = atol(argv[1]);
  x = atoi(argv[2]);

  fprintf(stderr,"n = %ld, x = %ld\n", n, x);
  
  /* Premier algorithme */
  debut  = clock();
  resultat = x;
  for(i=2; i<=n; i++) resultat = x * resultat;
  fprintf(stderr,"resultat = %ld\n",resultat);
  apres_premier = clock();

  /* Deuxieme algorithme */
  resultat = x;
  /*On determine d'abord le rang du bit de poids fort*/
  rang = sizeof(long int)*8-1; 
  while(((n >> rang)==0)&&(rang>0)) rang--;

  for(rang = rang-1; rang >=0; rang--){
    if ((n >> rang)&1){
      resultat = resultat * resultat;
      resultat = x*resultat;
    }
    else{
      resultat = resultat * resultat;
    }
  }
  fprintf(stderr,"resultat = %ld\n",resultat);
  apres_second  = clock();
    
  /* Affichage des temps d'execution*/
  fprintf(stderr,"Premier  algorithme: %.3lf\nDeuxieme algorithme: %.3lf\n",
	  (1.0*(apres_premier-debut))/CLOCKS_PER_SEC, 
	  (1.0*(apres_second-apres_premier))/CLOCKS_PER_SEC);
  return 0;
}
